## gocr 0.49

=== Makefile ===
#
#  type "make help" for help
#
# TODO: examples
#       add rpm to dist package, man page
#
# Changes:
# - be sure that configure is called after untgz, tar original file attributes
# - suggestion of Marcel Pol 6Dec2001:
#      make install DESTDIR=$RPM_BUILD_ROOT
#

prefix = /usr/local
#bindir = $(prefix)/bin
bindir = /usr/local${exec_prefix}/bin

SHELL = /bin/sh
# this does not work on SuSE 6.0, why? (autoconf 2.12 do not set /bin/sh ?)
#SHELL = bash #
INSTALL = /usr/bin/install -c
CC = gcc
CFLAGS = -g -O2
# following DEFs are not used, but I play with it for training
CPPFLAGS = -Wall -g -fexceptions -DDO_DEBUG=1 
DEFS = -DHAVE_CONFIG_H
includedir = ${prefix}/include
#
# -pedantic -ansi -Wall
LDFLAGS = -lm 
LIBS = -lnetpbm 

# RANLIB = @RANLIB@
# AR = @AR@


# files for devel.tgz
FILES = \
 AUTHORS Makefile Makefile.in bin/ doc/ include/ examples/ man/ src/\
 BUGS README make.bat CREDITS READMEde.txt REMARK.txt\
 HISTORY REVIEW configure gpl.html INSTALL TODO configure.in\
 install-sh gocr.spec .cvsignore

# files for distribution
AFILES = $(FILES) lib/

DIRS = doc/ include/ man/ examples/ bin/ src/ lib/

# export all make-variables to submakes - said to be not working on IRIS

# default rule
default: all

.PHONY : src doc examples help clean proper distclean dist tgz rpm libs

# example file generation takes lot of memory and time, do it explicitely
# by make examples
all:	src Makefile
	@echo " --- for help do: make help ---"
	@echo " --- for documentation do: make doc ---"
	@echo " --- for examples do: make examples ---"

include/config.h: include/config.h.in configure
	./configure

configure: configure.in
	autoconf

Makefile: Makefile.in configure
	./configure

src/Makefile: src/Makefile.in configure
	./configure

src:	src/Makefile
	$(MAKE) -C src all

libs:	src/Makefile
	$(MAKE) -C src libs

man:
	$(MAKE) -C man all

doc:
	$(MAKE) -C doc all

examples:
	$(MAKE) -C examples all

help:
	@printf "make            - compile all\n"
	@printf "make libs       - compile libraries libPgm2asc.{a,so}\n"
	@printf "make src        - build lib and gocr\n"
	@printf "make man        - build manual\n"
	@printf "make doc        - make documentation\n"
	@printf "make examples   - create examples ./examples/\n"
	@printf "make clean      - erase temporary files\n"
	@printf "make proper     - erase all created files\n"
	@printf "make install    - Really? Its development version!\n"
	@printf "make uninstall  - remove installed files from the system\n"


# you can override this variable by: make install DESTDIR=yourpath
DESTDIR=/usr/local
.PHONY : install uninstall test examples
install:
	$(MAKE) -C src install
	$(MAKE) -C man install
	# following steps are not needed for end users, but cost dependencies
	# therefore removed in 0.48
	# $(MAKE) -C doc install
	# $(MAKE) -C examples install
	# $(MAKE) -C frontend install

uninstall:
	$(MAKE) -C src uninstall
	$(MAKE) -C man uninstall
	# $(MAKE) -C doc uninstall
	# $(MAKE) -C examples uninstall
	# $(MAKE) -C frontend uninstall

# generate version file before packaging (most up to date)
#  release is the date of the last modified src file (for bug reports)
#  to distinguish different developper versions of same version number
include/version.h: src/*.[ch] Makefile
	echo "#define version_string \"0.49\"" > $@
	echo "#define release_string \"`date +%Y%m%d`\"" >> $@

dist: include/version.h
	echo gocr-0.49 > .fname
	-rm -rf `cat .fname`
	mkdir `cat .fname`
	# create subdirs, because cp -r bin/gocr.tcl jocr => jocr/gocr.tcl
	(cd `cat .fname`; mkdir $(DIRS))
	cp -r -p -d $(AFILES) `cat .fname`
	$(MAKE) -C `cat .fname` proper
	# for Win, DOS and Mac no configure available, reset config.h
	cp `cat .fname`/include/config.h.in `cat .fname`/include/config.h
	touch `cat .fname`/configure   # Makefile will be updated
	tar chzf ../`cat .fname`.tar.gz `cat .fname`
	-gpg -ab --default-key 0x53BDFBE3 ../`cat .fname`.tar.gz # .asc
	ls -l ../`cat .fname`.tar.gz{,.asc}
	-rm -rf `cat .fname` .fname


# the tgz-option is only for the author, to carry the sources home
tgz: include/version.h
	mkdir jocr		# causes an error if exist
	# create subdirs, because cp -r bin/gocr.tcl jocr => jocr/gocr.tcl
	(cd jocr; mkdir $(DIRS))
	-cp -rup -d $(FILES) CVS jocr
	$(MAKE) -C jocr proper
	if test -d jocr/src/api; then echo "--- rm -r jocr/src/api ---"; fi
	-rm -rf jocr/src/api
	# -rm -rf jocr/CVS jocr/*/CVS jocr/*/*/CVS # CVS tree
	-rm -rf jocr/Makefile jocr/src/Makefile jocr/include/config.h
	tar chzf ../jocr.tgz jocr
	-gpg -ab --default-key 0x53BDFBE3 ../jocr.tgz # .asc
	-cp ../jocr.tgz ../jocr.tgz.`date +%y%m%d` # backup, remove later
	ls -l ../jocr.tgz{,.asc}
	-rm -rf jocr

# the rpm option is for the author, to create simple rpm packages
TRPM = $(HOME)/tmp_gocr_build
# only gocr?
#VERSION=$(shell sed -e '/version_string/!d' -e 's/[^0-9.]*\([0-9.]*\).*/\1/' -e q src/gocr.c)
rpm:
	echo "%_topdir $(TRPM)" > ~/.rpmmacros
	mkdir -p $(TRPM)/{SOURCES,SPECS,BUILD,RPMS,SRPMS}
	sed "s/version.*[0-9]\.[0-9]*/version 0.49/"\
	 gocr.spec >$(TRPM)/SPECS/gocr.spec
	cp ../gocr-0.49.tar.gz $(TRPM)/SOURCES
	#rpmbuild -ba --nobuild gocr.spec  # bin+src-rpm
	(cd $(TRPM)/SPECS; rpmbuild -bb gocr.spec)
	rpm -qil -p $(TRPM)/RPMS/i?86/gocr-0.49-*.i?86.rpm

# PHONY = don't look at file clean, -rm = start rm and ignore errors
.PHONY : clean proper
clean:
	-rm -f config.cache config.status config.log
	-rm -f *.aux *.log *.dvi *.ps *.lj *~ gocr.ini out.txt
	-rm -f convert.cc convert convert.o	# remove v0.2.4 rests
	$(MAKE) -C src clean
	$(MAKE) -C doc clean
	$(MAKE) -C examples/ clean


distclean: proper

proper: clean
	$(MAKE) -C src/ proper
	$(MAKE) -C doc proper
	$(MAKE) -C examples/ proper
	-rm -f gocr bin/gocr libPgm2asc.* out??.bmp

=== examples/Makefile ===
#
# using convert from ImageMagick instead of my own jconv version v0.2.8
#   to crop the example images
#
# Version: @(#)ImageMagick 4.1.6 99/01/01 cristy@mystic.es.dupont.com
# Copyright: Copyright 1999 E. I. du Pont de Nemours and Company
# ... hmm, convert seems to use a lot of memory, pnmcrop works better
CROPPG = convert -crop 0x0+1+1

.PHONY: all examples fonts install uninstall clean proper proper_old gif jpg png

all: examples

help:
	echo " make examples       # Fig-examples (very fast)"
	echo " make examples_tex   # TeX-examples (takes lot of time)"
	echo " make [proper|clean] # remove non source stuff"

examples: font21.pcx font22.pcx font23.pcx font24.pcx ex.pcx inverse.pcx\
 rotate45.pcx
	ls -l *.pcx

examples_tex: text.pbm font0.pbm font1.pbm font2.pbm polish.pbm man.pbm
# what about small.pbm? anyone remember?

.SUFFIXES: .ps .tex .dvi .fig .pcx .png .jpg .gif .pbm .gz
.tex.dvi:
	latex $*.tex

.dvi.ps:
	dvips -E -o $*.ps $*.dvi    # -PAPERSIZE=a4

# default font size is 11*mag
# fig2dev can create pcx directly, but only unpacked and incompatible to xli
.fig.pcx:
	fig2dev -L ppm -m 3 $< | ppmtopcx -packed >$@

.fig.pbm:
	fig2dev -L ppm -m 3 $< | ppmtopgm | pgmtopbm -threshold >$@

.fig.png:
	fig2dev -L png -S 4 -m 3 $< >$@

.fig.gif:
	fig2dev -L gif -S 4 -m 3 $< >$@

.fig.jpg:
	fig2dev -L jpeg -S 4 -q 25 -m 3 $< >$@


# some make versions does not set $< in explicit rules (info autoconf)
font21.pcx: font2.fig
	fig2dev -L ppm -m 2 font2.fig | ppmtopcx -packed >$@
	# fig2dev -L pcx -m 2 font2.fig $@

font22.pcx: font2.fig
	fig2dev -L ppm -m 3 font2.fig | ppmtopcx -packed >$@
	# fig2dev -L pcx -m 3 font2.fig $@

font23.jpg: font2.fig
	fig2dev -L jpeg -m 4 font2.fig $@

font23.pgm: font2.fig
	fig2dev -L ppm -m 4 font2.fig | ppmtopgm >$@

font23.pbm: font2.fig
	fig2dev -L ppm -m 4 font2.fig | ppmtopgm | pgmtopbm >$@

font23.gif: font2.fig
	fig2dev -L gif -m 4 font2.fig $@

font23.pnm: font23.gif
	giftopnm $< >$@

font23.pcx: font2.fig
	fig2dev -L ppm -m 4 font2.fig | ppmtopcx -packed >$@

font24.pcx: font2.fig
	fig2dev -L ppm -m 5 font2.fig | ppmtopcx -packed >$@

font.tex: font1.tex
	cp font1.tex font.tex

# unfortunatly gs always creates a4 from boxed-ps, therefore we must crop it
# gs options: pgmraw, pcxmono, laserjet
font0.pbm: font.ps Makefile
	gs -dNOPAUSE -q -r600 -sDEVICE=pbmraw \
	 -sOutputFile=font0.pbm - < font.ps
#	$(CROPPG) font0.pbm font0.pbm
	pnmcrop font0.pbm >a.pbm; mv a.pbm font0.pbm

font1.pbm: font.ps Makefile
	gs -dNOPAUSE -q -r300 -sDEVICE=pbmraw \
	 -sOutputFile=font1.pbm - < font.ps
#	$(CROPPG) font1.pbm font1.pbm
	pnmcrop font1.pbm >a.pbm; mv a.pbm font1.pbm

font2.pbm: font.ps Makefile 
	gs -dNOPAUSE -q -r150 -sDEVICE=pbmraw \
	 -sOutputFile=font2.pbm - < font.ps
#	$(CROPPG) font2.pbm font2.pbm
	pnmcrop font2.pbm >a.pbm; mv a.pbm font2.pbm

polish.pbm: polish.ps Makefile 
	gs -dNOPAUSE -q -r200 -sDEVICE=pbmraw \
	 -sOutputFile=polish.pbm - < polish.ps
#	$(CROPPG) polish.pbm polish.pbm
	pnmcrop polish.pbm >a.pbm; mv a.pbm polish.pbm

text.pbm: text.ps Makefile
	gs -dNOPAUSE -q -r150 -sDEVICE=pbmraw \
	 -sOutputFile=text.pbm - < text.ps
#	 $(CROPPG) text.pbm text.pbm
	pnmcrop text.pbm >a.pbm; mv a.pbm text.pbm
	
small.pbm: small.ps Makefile
	gs -dNOPAUSE -q -r150 -sDEVICE=pbmraw \
	 -sOutputFile=small.pbm - < small.ps
#	 $(CROPPG) text.pbm text.pbm
	pnmcrop small.pbm >a.pbm; mv a.pbm small.pbm

# change this to make a man page to a test.pbm file
man.pbm: Makefile
	man -Tdvi man >man.dvi
	dvips -o man.ps man.dvi
	gs -dNOPAUSE -q -r300 -sDEVICE=pbmraw \
	 -sOutputFile=man.pbm - < man.ps
#	$(CROPPG) man.pbm man.pbm
	pnmcrop man.pbm >a.pbm; mv a.pbm man.pbm
	rm -f man.ps man.dvi

fonts: font0.pbm font1.pbm font2.pbm

clean:
	-rm -f a *.bak *.aux *.log *.dvi man.ps text.ps font.ps polish.ps *~

# two ways to remove examples
# 1) expand all *.gif *.p?m ... and check if basname.fig exist
# 2) expand all *.fig and remove basename.{gif,p?m}
# works only with GnuMake:
suffix:=%.pbm %.pgm %.ppm %.pcx %.png %.gif %.jpg
figobj:= $(filter $(suffix),$(wildcard $(patsubst %.fig,%.*,$(wildcard *.fig))))
# figobj:= $(foreach var,$(wildcard *.p[bgp]m *.pcx *.png *.gif *.jpg),$(if $(wildcard $(basename $(var)).fig),$(var)))
# shell: 
proper: clean
	-rm -f ./font2[1234].{p[bgp]m,pcx,png,gif,jpg}
	-rm -f $(figobj)

proper_old:
	# -rm -f ./{ex,inverse,rotate45,font2[1234]}.{p[bgpna]m,pcx,png,gif,jpg}
	-for xx in *.fig; do\
	 rm -f ./$$(echo $${xx} | sed 's/.fig$$//'){,1,2,3,4}.{p[bgpn]m,pcx,png,gif,jpg} 2>/dev/null;\
	done

gif: $(patsubst %.fig,%.gif,$(wildcard *.fig))
	ls -l *.gif

png: $(patsubst %.fig,%.png,$(wildcard *.fig))
	ls -l *.png

jpg: $(patsubst %.fig,%.jpg,$(wildcard *.fig))
	ls -l *.jpg

install:

uninstall:

=== man/Makefile ===
#
# Makefile for ./man path, used by configure
#

PROGRAM = gocr

mandir = ${prefix}/man

INSTALL=/usr/bin/install -c
DESTDIR=/usr/local

default: all

all:

# PHONY = don't look at file clean, -rm = start rm and ignore errors
.PHONY : clean proper install uninstall
install: all
	$(INSTALL) -d $(DESTDIR)$(mandir)/man1
	$(INSTALL) ../man/man1/$(PROGRAM).1 $(DESTDIR)$(mandir)/man1

uninstall:
	-rm -f $(DESTDIR)$(mandir)/man1/$(PROGRAM).1

clean:
	-rm -f *.o *~

proper: clean

=== src/Makefile ===
#
# Makefile for ./src path, used by configure
#

EXEEXT = 
PROGRAM = gocr$(EXEEXT)
# lib removed for simplification (v0.46)
# but Igor from OSRA an optical chemical structure recognition software 
#  wants it (v0.47 Mar09)
PGMASCLIB = Pgm2asc
#LIBPGMASCLIB = lib$(PGMASCLIB).a
# ToDo: need a better pgm2asc.h for lib users 
#INCLUDEFILES = gocr.h
# avoid german compiler messages
LANG=C

LIBOBJS=pgm2asc.o \
	box.o \
	database.o \
	detect.o \
	barcode.o \
	lines.o \
	list.o \
	ocr0.o \
	ocr0n.o \
	ocr1.o \
	otsu.o \
	output.o \
	pixel.o \
	unicode.o \
	remove.o \
	pnm.o \
	pcx.o \
	progress.o \
	job.o

# these two lines are for cross-compiling, not tested
#srcdir = .
#VPATH = .
bindir = ${exec_prefix}/bin
#  lib removed for simplification
#libdir = ${exec_prefix}/lib
#includedir = ${prefix}/include

CC=gcc
# lib removed for simplification
# ar,ranlib detection removed from configure (simplicity)
#  but needed by some developpers (linux only) for for (make libs)
# RANLIB = @RANLIB@
# AR = @AR@
RANLIB = ranlib
AR = ar
INSTALL=/usr/bin/install -c
# shell is needed for OS/2 to let if test -r $(PROGRAM) ... work
SHELL=/bin/sh

DEFS=-DHAVE_CONFIG_H
CPPFLAGS=-Wall -g -fexceptions -DDO_DEBUG=1 
# to see the config.h
CFLAGS=-g -O2 $(CPPFLAGS) -I../include $(DEFS)
LDFLAGS=-lm 
LIBS=-lnetpbm 
DESTDIR=/usr/local

.SUFFIXES: .s .o .c .h
# do not look for files if help (etc) is given
.PHONY : doc clean install libs default

.c.o: gocr.h pgm2asc.h ../include/config.h
	$(CC) $(CFLAGS) -c -o $*.o $<

default: all

# all: $(PROGRAM) lib$(PGMASCLIB).a
all: $(PROGRAM)

gocr.o: gocr.h Makefile ../include/version.h

.c.h:

# Aug2010
unicode.o: unicode_defs.h
list.o pgm2asc.o: list.h

#$(PROGRAM): lib$(PGMASCLIB).a gocr.o
$(PROGRAM): $(LIBOBJS) gocr.o
	# make it conform to ld --as-needed
	#$(CC) -o $@ $(LDFLAGS) gocr.o ./lib$(PGMASCLIB).a $(LIBS)
	$(CC) -o $@ $(LDFLAGS) gocr.o $(LIBOBJS) $(LIBS)
	# if test -r $(PROGRAM); then cp $@ ../bin; fi

libs: lib$(PGMASCLIB).a lib$(PGMASCLIB).0.49.so

#lib$(PGMASCLIB).0.49.so: $(LIBOBJS)
#	$(CC) -fPIC -shared -Wl,-h$@ -o $@ $(LIBOBJS)
lib$(PGMASCLIB).0.49.so: $(LIBOBJS:%.o=%.c) Makefile
	# .o must be build with -fPIC too (Aug2010 JS)
	$(CC) $(CFLAGS) -fPIC -shared -Wl,-h$@ -o $@ $(LIBOBJS:%.o=%.c)
	-rm -f lib$(PGMASCLIB).so  # set new link
	-ln -s $@ lib$(PGMASCLIB).so

lib$(PGMASCLIB).a: $(LIBOBJS)
	#	-rm -f $@
	$(AR) cru $@ $(LIBOBJS)
	$(RANLIB) $@

$(LIBOBJS): Makefile

# PHONY = don't look at file clean, -rm = start rm and ignore errors
.PHONY : clean proper install uninstall
install: all
	#$(INSTALL) -d $(DESTDIR)$(bindir) $(DESTDIR)$(libdir) $(DESTDIR)$(includedir)
	$(INSTALL) -d $(DESTDIR)$(bindir)
	$(INSTALL) $(PROGRAM) $(DESTDIR)$(bindir)
	$(INSTALL) ../bin/gocr.tcl   $(DESTDIR)$(bindir)  # better X11/bin?
	if test -f lib$(PGMASCLIB).a; then\
	 $(INSTALL) lib$(PGMASCLIB).a $(DESTDIR)$(libdir);\
	 $(INSTALL) lib$(PGMASCLIB).0.49.so $(DESTDIR)$(libdir);\
	 $(INSTALL) lib$(PGMASCLIB).so $(DESTDIR)$(libdir);\
	fi
	# ToDo: not sure that the link will be installed correctly
	#$(INSTALL) $(INCLUDEFILES) $(DESTDIR)$(includedir)

# directories are not removed
uninstall:
	-rm -f $(DESTDIR)$(bindir)/$(PROGRAM)
	-rm -f $(DESTDIR)$(bindir)/gocr.tcl
	-rm -f $(DESTDIR)$(libdir)/lib$(PGMASCLIB).a
	-rm -f $(DESTDIR)$(libdir)/lib$(PGMASCLIB).0.49.so
	-rm -f $(DESTDIR)$(libdir)/lib$(PGMASCLIB).so
	# ToDo: set to old version.so ?
	#for X in $(INCLUDEFILES); do rm -f $(DESTDIR)$(includedir)/$$X; done

clean:
	-rm -f *.o *~

proper: clean
	-rm -f gocr libPgm2asc.*
	-rm -f gocr

=== debian/changelog ===
gocr (0.49-1) unstable; urgency=low

  * New upstream release.
  * Using dpkg-source --commit and quilt, Fixes: #643141
  * README.Debian moved to NEWS.DEbian, Fixes: #596855
  * Removed some confusing examples, Fixes: #596863

 -- Cosimo Alfarano <kalfa@debian.org>  Tue, 22 Nov 2011 13:09:35 +0000

gocr (0.48-1) unstable; urgency=low

  * New upstream version
  * Repackaged using a newer debhelper infrastructure
  * using debian/source/format 3.0 (quilt)

 -- Cosimo Alfarano <kalfa@debian.org>  Mon, 19 Mar 2010 12:40:04 +0000

gocr (0.46-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Pass --mandir to ./configure (Closes: #553095)

 -- David Paleino <dapal@debian.org>  Mon, 09 Nov 2009 22:40:04 +0100

gocr (0.46-2) unstable; urgency=low

  * Fixed /usr/man usage for manpages updating files from /usr/share/misc/config.{guess,sub}  (Closes: #505621)
  * added Debian revision number and orig file

 -- Cosimo Alfarano <kalfa@debian.org>  Thu, 13 Nov 2008 21:02:24 -0200

gocr (0.46) unstable; urgency=low

  * New upstream release
  * Fixed bug with space in filename (Closes: #316511,#433900)

 -- Cosimo Alfarano <kalfa@debian.org>  Sat, 08 Nov 2008 12:36:55 -0200

gocr (0.45-2) unstable; urgency=low

  * Fixed typos in manpages (Closes: #409580)
  * new upstream wishbug bug not previouly closed (Closes: #405957)

 -- Cosimo Alfarano <kalfa@debian.org>  Fri, 18 Jul 2008 12:08:37 -0400

gocr (0.45-1) unstable; urgency=low

  * set Prority to optional
  * Closes: #402799 

 -- Cosimo Alfarano <kalfa@debian.org>  Sat, 05 Jul 2008 04:46:28 -0400

gocr (0.45-0) unstable; urgency=low

  * New Version upload

 -- Cosimo Alfarano <kalfa@debian.org>  Fri, 04 Jul 2008 20:42:31 -0400

gocr (0.41-1) unstable; urgency=low

  * new upstream version
    Closes: #388217
  * fixed gnome-frontend (frontend/gnome/src/functions.c) string quoting
    (debian/patches/gnome-frontend-functions.c.patch_allow_spaces)
  * fixed gnome-frontend showing button
    (debian/patches/gnome-frontend-functions.c.patch_show_buttons)
  * applied debian/patches/gocr-0.41-pgm.patch from upstream
  * quoted dashes in gocr.1 man page
    Closes: #272590

 -- Cosimo Alfarano <kalfa@debian.org>  Thu,  9 Nov 2006 14:08:47 +0100

gocr (0.39-5) unstable; urgency=high

  * security fix for http://www.overflow.pl/adv/gocr.txt
    Closes: #305068
  * copied src/pnm.c from 0.40 and patched gocr.c
    according to upstream, it's the best way to backport the fix from 0.40

 -- Cosimo Alfarano <kalfa@debian.org>  Wed, 20 Apr 2005 00:12:48 +0200

gocr (0.39-4) unstable; urgency=low

  * recommends libjpeg-progs, bzip2, netpbm, transfig in control
    (see pnm.c for list of autoinvoked command)
    Closes: #272282

 -- Cosimo Alfarano <kalfa@debian.org>  Sun, 19 Sep 2004 23:07:05 +0200

gocr (0.39-3) unstable; urgency=low

  * apply patches by Nicolas Fran\347ois for gocr-gtk
    that fix a problem with opening file with spaces and opening two files
    Closes: #197827,#197814

 -- Cosimo Alfarano <kalfa@debian.org>  Mon, 26 Jul 2004 18:19:33 +0200

gocr (0.39-2) unstable; urgency=low

  * debian/control: added Suggests: gocr-doc to gocr 
    closes: Bug#254827

 -- Cosimo Alfarano <kalfa@debian.org>  Thu, 15 Jul 2004 00:47:52 +0200

gocr (0.39-1) unstable; urgency=low

  * New upstream release
    closes: Bug#244223

 -- Cosimo Alfarano <kalfa@debian.org>  Sat, 17 Apr 2004 15:19:09 +0200

gocr (0.38-4) unstable; urgency=low

  * fixes the previous entry, that was upload by mistake without updating it
    :( 
  * built against libnetpbm10 (Build-Depends updated)
    closes: Bug#211258

 -- Cosimo Alfarano <kalfa@debian.org>  Thu, 25 Mar 2004 22:27:14 +0100

gocr (0.38-3) unstable; urgency=low

  * libnetpbm10 

 -- Cosimo Alfarano <kalfa@debian.org>  Thu, 25 Mar 2004 21:44:35 +0100

gocr (0.38-2) unstable; urgency=low

  * removed tk8.4-dev from Build-Depends, thanks to Florent Rougon
    closes: Bug#227533
  * suggesting xsane to goct-tk, since it can scan a document from GUI

 -- Cosimo Alfarano <kalfa@debian.org>  Tue, 23 Mar 2004 11:02:54 +0100

gocr (0.38-1) unstable; urgency=low

  * New Upstream Release

 -- Cosimo Alfarano <kalfa@debian.org>  Wed, 24 Dec 2003 19:37:25 +0100

gocr (0.37-3) unstable; urgency=low

  * debian/rules: ignore errorcode of find if CVS dir and some other files are
    not found during clean target execution
    closes: Bug#199933

 -- Cosimo Alfarano <kalfa@debian.org>  Fri,  4 Jul 2003 16:06:26 +0200

gocr (0.37-2) unstable; urgency=low

  * added autoconf in Build-Depends
    closes: Bug#199756
  * binary-arch target now depends on install target. it was forgot in some
    way
    closes: Bug#191633

 -- Cosimo Alfarano <kalfa@debian.org>  Thu,  3 Jul 2003 21:16:34 +0200

gocr (0.37-1) unstable; urgency=low

  * reuploading the old debian 0.3.7-1 version with the real upstream version
    fixed. it's 0.37!
  * changed deps of gocr-tk to respect current sid's tk version.
    (closes: Bug#194794)

 -- Cosimo Alfarano <kalfa@debian.org>  Tue, 27 May 2003 15:19:14 +0200

gocr (0.3.7-1) unstable; urgency=low

  * New Upstream Version  (closes: #173595)
  * Installed new gocr man page from sources (closes: Bug#174182,Bug#151736)

 -- Cosimo Alfarano <kalfa@debian.org>  Fri, 27 Dec 2002 19:29:24 +0100

gocr (0.3.4-10) unstable; urgency=low

  * fixed some typos in debian/control (closes: #142504,#142735)

 -- Cosimo Alfarano <kalfa@debian.org>  Tue, 16 Apr 2002 14:07:04 +0200

gocr (0.3.4-9) unstable; urgency=low

  * fixed gtk-ocr segfault during setting (closes: Bug#136913) 
    modified line are tagged "//KA"

 -- Cosimo Alfarano <kalfa@debian.org>  Tue,  5 Mar 2002 16:47:56 +0100

gocr (0.3.4-8) unstable; urgency=low

  *  arch-dep and arch-indep packages splitted in debian/rules

 -- Cosimo Alfarano <kalfa@debian.org>  Fri, 22 Feb 2002 19:18:53 +0100

gocr (0.3.4-7) unstable; urgency=low

  * fixed a type in Description (closes: Bug#125619)


=== debian/control ===
Source: gocr
Section: graphics
Priority: optional
Maintainer: Cosimo Alfarano <kalfa@debian.org>
Build-Depends: debhelper (>= 8.0.0), autotools-dev
Standards-Version: 3.9.2
Homepage: http://jocr.sourceforge.net/
#Vcs-Git: git://git.debian.org/collab-maint/gocr.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/gocr.git;a=summary

Package: gocr
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libjpeg-progs, bzip2, netpbm, transfig
Description: Command line OCR
 gocr is a multi-platform OCR (Optical Character Recognition) program.
 .
 It can read pnm, pbm, pgm, ppm, some pcx and tga image files.
 .
 Currently the program should be able to handle well scans that have their text
 in one column and do not have tables. Font sizes of 20 to 60
 pixels are supported.
 .
 If you want to write your own OCR, libgocr is provided in a separate
 package. Documentation and graphical wrapper are provided in separated
 packages, too.

Package: gocr-tk
Architecture: all
Depends: gocr, tk8.5 | wish, ${misc:Depends}
Suggests: xsane
Description: tcl/tk wrapper around gocr
 gocr is a multi-platform OCR (Optical Character Recognition) program.
 .
 It can read pnm, pbm, pgm, ppm, some pcx and tga image files.
 .
 It is a tlc/tk GUI to gocr (a command line program).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

override_dh_install:
	mv $(CURDIR)/debian/tmp/bin/gocr.tcl $(CURDIR)/debian/tmp/bin/gocr-tk
	dh_install

%:
	dh $@

## gocr 0.52

=== Makefile ===
--- 
+++ 
@@ -27,7 +27,7 @@
 #
 # -pedantic -ansi -Wall
 LDFLAGS = -lm 
-LIBS = -lnetpbm 
+LIBS = 
 
 # RANLIB = @RANLIB@
 # AR = @AR@
@@ -55,9 +55,10 @@
 # example file generation takes lot of memory and time, do it explicitely
 # by make examples
 all:	src Makefile
-	@echo " --- for help do: make help ---"
-	@echo " --- for documentation do: make doc ---"
-	@echo " --- for examples do: make examples ---"
+	@echo " --- for help do:          make help"
+	@echo " --- for documentation do: make doc"
+	@echo " --- for examples do:      make examples"
+	@echo " --- for testing do:       bin/gocr_chk.sh [testbasedir?=.]"
 
 include/config.h: include/config.h.in configure
 	./configure
@@ -65,11 +66,11 @@
 configure: configure.in
 	autoconf
 
-Makefile: Makefile.in configure
-	./configure
+src/Makefile Makefile: Makefile.in src/Makefile.in configure
+	./configure --with-debug
 
-src/Makefile: src/Makefile.in configure
-	./configure
+#src/Makefile: src/Makefile.in configure
+#	./configure
 
 src:	src/Makefile
 	$(MAKE) -C src all
@@ -122,11 +123,13 @@
 #  release is the date of the last modified src file (for bug reports)
 #  to distinguish different developper versions of same version number
 include/version.h: src/*.[ch] Makefile
-	echo "#define version_string \"0.49\"" > $@
+	echo "/* WARNING: this file is autogenerated by Makefile */" > $@
+	echo "/*   edit configure.in to set a new version number */" >> $@
+	echo "#define version_string \"0.52\"" >> $@
 	echo "#define release_string \"`date +%Y%m%d`\"" >> $@
 
 dist: include/version.h
-	echo gocr-0.49 > .fname
+	echo gocr-0.52 > .fname
 	-rm -rf `cat .fname`
 	mkdir `cat .fname`
 	# create subdirs, because cp -r bin/gocr.tcl jocr => jocr/gocr.tcl
@@ -137,7 +140,8 @@
 	cp `cat .fname`/include/config.h.in `cat .fname`/include/config.h
 	touch `cat .fname`/configure   # Makefile will be updated
 	tar chzf ../`cat .fname`.tar.gz `cat .fname`
-	-gpg -ab --default-key 0x53BDFBE3 ../`cat .fname`.tar.gz # .asc
+	# avoid popping up x11-gpg-agent: DISPLAY=""
+	-DISPLAY="" gpg -ab --default-key 0x53BDFBE3 ../`cat .fname`.tar.gz # .asc
 	ls -l ../`cat .fname`.tar.gz{,.asc}
 	-rm -rf `cat .fname` .fname
 
@@ -154,7 +158,8 @@
 	# -rm -rf jocr/CVS jocr/*/CVS jocr/*/*/CVS # CVS tree
 	-rm -rf jocr/Makefile jocr/src/Makefile jocr/include/config.h
 	tar chzf ../jocr.tgz jocr
-	-gpg -ab --default-key 0x53BDFBE3 ../jocr.tgz # .asc
+	# avoid popping up x11-gpg-agent
+	-DISPLAY="" gpg -ab --default-key 0x53BDFBE3 ../jocr.tgz # .asc
 	-cp ../jocr.tgz ../jocr.tgz.`date +%y%m%d` # backup, remove later
 	ls -l ../jocr.tgz{,.asc}
 	-rm -rf jocr
@@ -166,12 +171,12 @@
 rpm:
 	echo "%_topdir $(TRPM)" > ~/.rpmmacros
 	mkdir -p $(TRPM)/{SOURCES,SPECS,BUILD,RPMS,SRPMS}
-	sed "s/version.*[0-9]\.[0-9]*/version 0.49/"\
+	sed "s/version.*[0-9]\.[0-9]*/version 0.52/"\
 	 gocr.spec >$(TRPM)/SPECS/gocr.spec
-	cp ../gocr-0.49.tar.gz $(TRPM)/SOURCES
+	cp ../gocr-0.52.tar.gz $(TRPM)/SOURCES
 	#rpmbuild -ba --nobuild gocr.spec  # bin+src-rpm
 	(cd $(TRPM)/SPECS; rpmbuild -bb gocr.spec)
-	rpm -qil -p $(TRPM)/RPMS/i?86/gocr-0.49-*.i?86.rpm
+	rpm -qil -p $(TRPM)/RPMS/i?86/gocr-0.52-*.i?86.rpm
 
 # PHONY = don't look at file clean, -rm = start rm and ignore errors
 .PHONY : clean proper
@@ -190,4 +195,4 @@
 	$(MAKE) -C src/ proper
 	$(MAKE) -C doc proper
 	$(MAKE) -C examples/ proper
-	-rm -f gocr bin/gocr libPgm2asc.* out??.bmp
+	-rm -f gocr bin/gocr libPgm2asc.* out[0-9][0-9].{bmp,png}

=== doc/Makefile ===
#
# Makefile for ./doc path, used by configure
#

# these two lines are for cross-compiling, not tested
#srcdir = .
#VPATH = .

# changed to html, tex is not used anymore
#LATEX=@LATEX@
#DVIPS=@DVIPS@

OCRDOC=ocr
# add other source file to documentation here
# SRC=$(OCRDOC).tex

.PHONY : all clean proper install uninstall
default: all

all:	# do nothing!

#$(OCRDOC).ps: $(OCRDOC).dvi
#	$(DVIPS) -o $(OCRDOC).ps $?
#
#$(OCRDOC).dvi: $(SRC)
#	$(LATEX) $(OCRDOC).tex

install: all
	echo "Copy gocr.html to your document path."

uninstall:
	echo "Remove gocr.html from your document path."

clean:
	-rm -f *.bak *~ $(OCRDOC).{dvi,log,aux}

proper: clean
	-rm -f $(OCRDOC).ps

=== examples/Makefile ===
--- 
+++ 
@@ -5,6 +5,24 @@
 # Version: @(#)ImageMagick 4.1.6 99/01/01 cristy@mystic.es.dupont.com
 # Copyright: Copyright 1999 E. I. du Pont de Nemours and Company
 # ... hmm, convert seems to use a lot of memory, pnmcrop works better
+#
+# convert -size 640x200 xc:white -pointsize 80 -fill black\
+#  -font "FreeMono-Regular" 
+#  -draw 'text 2,80  "Hex-qEETWWMM"' 
+#  -draw 'text 2,160 "xQÖFig.queft"' a.png # x=36x34 M=(46+2)*46 mono=48
+# # -pointsize 14 -font "FreeMono-Regular"   # (2+2+6+3+1)x(7+1) 
+# # -pointsize 16 -font "FreeMono-Regular"   # (3+2+7+3+1)x(9+1) 
+# # -pointsize 20 -font "FreeMono-Regular"   # (3+3+9+4+1)x(12) 
+# # -pointsize 31 -font "FreeMono-Regular"   # (5+4+13+6+1)x(18+1)  WW
+# # -pointsize 50 -font "FreeMono-Regular"   # (7+8+23+8+4)x(29+1)  WW
+# # -pointsize 60 -font "FreeMono-Regular"   # (9+9+25+11+4)x(29+1)  MM
+#  O is 1 pix higher + 1 pix below XHM, W is 1 pix below XHM
+#  i-dot is -4 to 2 at FXH-top
+#   round chars have 1 pixel above top and below ground-line
+# dd if=/dev/urandom bs=57  count=1 status=noxfer 2>/dev/null|base64 # 77x1
+# dd if=/dev/urandom bs=285 count=1 status=noxfer 2>/dev/null|base64 # 77x5
+# convert -list font | grep Mono # grep Font
+#
 CROPPG = convert -crop 0x0+1+1
 
 .PHONY: all examples fonts install uninstall clean proper proper_old gif jpg png
@@ -17,8 +35,8 @@
 	echo " make [proper|clean] # remove non source stuff"
 
 examples: font21.pcx font22.pcx font23.pcx font24.pcx ex.pcx inverse.pcx\
- rotate45.pcx
-	ls -l *.pcx
+ rotate45.pcx rnd80.png
+	ls -l *.pcx *.png
 
 examples_tex: text.pbm font0.pbm font1.pbm font2.pbm polish.pbm man.pbm
 # what about small.pbm? anyone remember?
@@ -144,7 +162,7 @@
 # shell: 
 proper: clean
 	-rm -f ./font2[1234].{p[bgp]m,pcx,png,gif,jpg}
-	-rm -f $(figobj)
+	-rm -f $(figobj) rnd80.png.txt rnd80.png
 
 proper_old:
 	# -rm -f ./{ex,inverse,rotate45,font2[1234]}.{p[bgpna]m,pcx,png,gif,jpg}
@@ -161,6 +179,23 @@
 jpg: $(patsubst %.fig,%.jpg,$(wildcard *.fig))
 	ls -l *.jpg
 
+# added 2018-09 285=57chars/line*5lines
+rnd80.png.txt:
+	dd if=/dev/urandom bs=285 count=1 status=noxfer 2>/dev/null\
+ | base64 > $@
+
+# convert -list font | grep Font # ToDo: try others Liberation-Mono-Regular ...
+#   Nimbus-Mono-Regular DejaVu-Sans-Mono-Book Droid-Sans-Mono-Regular
+#   Liberation-Mono-Regular  # small chars are artificial wided
+rnd80.png: rnd80.png.txt
+	convert -size 3800x600 xc:white -pointsize 80 -fill black\
+ -font "FreeMono-Regular"\
+ -draw "text 2,80  \"$(shell head -1 <rnd80.png.txt)\""\
+ -draw "text 2,160 \"$(shell head -2 <rnd80.png.txt| tail -1)\""\
+ -draw "text 2,240 \"$(shell head -3 <rnd80.png.txt| tail -1)\""\
+ -draw "text 2,320 \"$(shell head -4 <rnd80.png.txt| tail -1)\""\
+ -draw "text 2,400 \"$(shell head -5 <rnd80.png.txt| tail -1)\"" $@ # x=36x34 M=(46+2)*46 mono=48
+
 install:
 
 uninstall:

=== man/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 PROGRAM = gocr
 
-mandir = ${prefix}/man
+mandir = ${prefix}/share/man
 
 INSTALL=/usr/bin/install -c
 DESTDIR=/usr/local

=== src/Makefile ===
--- 
+++ 
@@ -59,7 +59,7 @@
 # to see the config.h
 CFLAGS=-g -O2 $(CPPFLAGS) -I../include $(DEFS)
 LDFLAGS=-lm 
-LIBS=-lnetpbm 
+LIBS=
 DESTDIR=/usr/local
 
 .SUFFIXES: .s .o .c .h
@@ -89,11 +89,11 @@
 	$(CC) -o $@ $(LDFLAGS) gocr.o $(LIBOBJS) $(LIBS)
 	# if test -r $(PROGRAM); then cp $@ ../bin; fi
 
-libs: lib$(PGMASCLIB).a lib$(PGMASCLIB).0.49.so
+libs: lib$(PGMASCLIB).a lib$(PGMASCLIB).0.52.so
 
-#lib$(PGMASCLIB).0.49.so: $(LIBOBJS)
+#lib$(PGMASCLIB).0.52.so: $(LIBOBJS)
 #	$(CC) -fPIC -shared -Wl,-h$@ -o $@ $(LIBOBJS)
-lib$(PGMASCLIB).0.49.so: $(LIBOBJS:%.o=%.c) Makefile
+lib$(PGMASCLIB).0.52.so: $(LIBOBJS:%.o=%.c) Makefile
 	# .o must be build with -fPIC too (Aug2010 JS)
 	$(CC) $(CFLAGS) -fPIC -shared -Wl,-h$@ -o $@ $(LIBOBJS:%.o=%.c)
 	-rm -f lib$(PGMASCLIB).so  # set new link
@@ -115,7 +115,7 @@
 	$(INSTALL) ../bin/gocr.tcl   $(DESTDIR)$(bindir)  # better X11/bin?
 	if test -f lib$(PGMASCLIB).a; then\
 	 $(INSTALL) lib$(PGMASCLIB).a $(DESTDIR)$(libdir);\
-	 $(INSTALL) lib$(PGMASCLIB).0.49.so $(DESTDIR)$(libdir);\
+	 $(INSTALL) lib$(PGMASCLIB).0.52.so $(DESTDIR)$(libdir);\
 	 $(INSTALL) lib$(PGMASCLIB).so $(DESTDIR)$(libdir);\
 	fi
 	# ToDo: not sure that the link will be installed correctly
@@ -126,7 +126,7 @@
 	-rm -f $(DESTDIR)$(bindir)/$(PROGRAM)
 	-rm -f $(DESTDIR)$(bindir)/gocr.tcl
 	-rm -f $(DESTDIR)$(libdir)/lib$(PGMASCLIB).a
-	-rm -f $(DESTDIR)$(libdir)/lib$(PGMASCLIB).0.49.so
+	-rm -f $(DESTDIR)$(libdir)/lib$(PGMASCLIB).0.52.so
 	-rm -f $(DESTDIR)$(libdir)/lib$(PGMASCLIB).so
 	# ToDo: set to old version.so ?
 	#for X in $(INCLUDEFILES); do rm -f $(DESTDIR)$(includedir)/$$X; done

=== debian/changelog ===
gocr (0.52-6) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Fix day-of-week for changelog entries 0.48-1, 0.3.4-4, 0.2.7-2.
  * Apply multi-arch hints. + libpgm2asc0.52: Add Multi-Arch: same.

  [ Andrius Merkys ]
  * Build depend on libnetpbm-dev instead of libnetpbm11-dev (Closes: #1028899)
  * Bump copyright years.

 -- Andrius Merkys <merkys@debian.org>  Mon, 16 Jan 2023 03:54:18 -0500

gocr (0.52-5) unstable; urgency=medium

  * Run build time tests.
  * Add autopkgtest.

 -- Andrius Merkys <merkys@debian.org>  Wed, 24 Aug 2022 03:14:03 -0400

gocr (0.52-4) unstable; urgency=medium

  * New maintainer (Closes: #974153). Thanks Gürkan Myczko for your work!
  * Bump debhelper-compat (no changes).
  * Remove build depends on autotools-dev (already satisfied).
  * Provide shared library for libpgm2asc. (Closes: #962787, #1014337)
  * Rename gocr-dev to libpgm2asc-dev.
  * Provide config.h in libpgm2asc-dev. (Closes: #1014165)
  * Disable parallel builds as they sometimes fail.
  * Build using libnetpbm11-dev.
  * Clean up package dependencies.
  * Add watch file.
  * Rename debian/NEWS.Debian to debian/NEWS, fix syntax problems.

 -- Andrius Merkys <merkys@debian.org>  Tue, 23 Aug 2022 01:53:53 -0400

gocr (0.52-3) unstable; urgency=medium

  * debian/control: move the xli Depends to the right binary package.
    (Closes: #935291)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 02 Sep 2019 17:20:38 +0200

gocr (0.52-2) unstable; urgency=medium

  * debian/control: add xli to Depends. (LP: #364859)

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 12 Aug 2019 13:17:45 +0200

gocr (0.52-1) unstable; urgency=medium

  * New upstream version. (Closes: #743719, #877087, #293727)
  * Add myself as Uploaders. (Closes: #846818)
  * debian/patches: dropped them all.
  * debian/rules: update to install changelog. (Closes: #596858)
  * Patched upstream manual page to refer to right package. (Closes: #676856)
  * New binary package, gocr-dev. (Closes: #582575)
  * debian/copyright: made machine readable, updated.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Thu, 24 Jan 2019 13:20:02 +0100

gocr (0.49-2) unstable; urgency=low

  * Use tk instead of tk8.5 (Closes: Bug#725690)

 -- Cosimo Alfarano <kalfa@debian.org>  Thu, 04 Sep 2014 09:36:38 +0100

=== debian/control ===
Source: gocr
Section: graphics
Priority: optional
Maintainer: Andrius Merkys <merkys@debian.org>
Build-Depends:
 bzip2 <!nocheck>,
 debhelper-compat (= 13),
 libjpeg-progs <!nocheck>,
 libnetpbm-dev,
 netpbm <!nocheck>,
Standards-Version: 4.2.1
Homepage: https://www-e.uni-magdeburg.de/jschulen/ocr/
Vcs-Browser: https://salsa.debian.org/debian/gocr
Vcs-Git: https://salsa.debian.org/debian/gocr.git

Package: gocr
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 bzip2,
 libjpeg-progs,
 netpbm,
 transfig,
Description: Command line OCR
 This is a multi-platform OCR (Optical Character Recognition) program.
 .
 It can read pnm, pbm, pgm, ppm, some pcx and tga image files.
 .
 Currently the program should be able to handle well scans that have their text
 in one column and do not have tables. Font sizes of 20 to 60
 pixels are supported.
 .
 If you want to write your own OCR, libgocr is provided in a separate
 package. Documentation and graphical wrapper are provided in separated
 packages, too.

Package: gocr-tk
Architecture: all
Depends:
 gocr,
 tk | wish,
 xli,
 ${misc:Depends},
Suggests:
 xsane,
Description: tcl/tk wrapper around gocr
 This is a multi-platform OCR (Optical Character Recognition) program.
 .
 It can read pnm, pbm, pgm, ppm, some pcx and tga image files.
 .
 It is a tlc/tk GUI to gocr (a command line program).

Package: libpgm2asc-dev
Architecture: any
Section: libdevel
Depends:
 libpgm2asc0.52 (= ${binary:Version}),
 ${misc:Depends},
Provides:
 gocr-dev,
Conflicts:
 gocr-dev,
Replaces:
 gocr-dev,
Description: Command line OCR - development files
 This is a multi-platform OCR (Optical Character Recognition) program.
 .
 It can read pnm, pbm, pgm, ppm, some pcx and tga image files.
 .
 These are the development files.

Package: libpgm2asc0.52
Architecture: any
Section: libs
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: Command line OCR - shared library
 This is a multi-platform OCR (Optical Character Recognition) program.
 .
 It can read pnm, pbm, pgm, ppm, some pcx and tga image files.
 .
 This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --no-parallel

override_dh_auto_build:
	dh_auto_build -- all libs

override_dh_auto_test:
	bin/gocr_chk.sh

override_dh_install:
	mv $(CURDIR)/debian/tmp/bin/gocr.tcl $(CURDIR)/debian/tmp/bin/gocr-tk
	ln -fs libPgm2asc.so.0.52 $(CURDIR)/debian/tmp/libPgm2asc.so
	dh_install

override_dh_installchangelogs:
	dh_installchangelogs HISTORY

=== debian/tests/control ===
Test-Command: bin/gocr_chk.sh
Depends:
 bzip2,
 gocr,
 libjpeg-progs,
 netpbm,

=== debian/watch ===
version=4
https://www-e.uni-magdeburg.de/jschulen/ocr/download.html \
 http://www-e.uni-magdeburg.de/jschulen/ocr/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
